TITLE1 "P0201.SAS-Reproducing numbers in Table 1";

PROC IML WORK=20000 SYMSIZE=2000;

%INCLUDE "..\IML\ARLIB1.IML"/NOSOURCE2;
%INCLUDE "..\IML\INTLIB3.IML" /  SOURCE2;
%INCLUDE "..\IML\INTLIB4.IML"/NOSOURCE2;
%INCLUDE "..\IML\AS155LB1.IML"/NOSOURCE2;

START EVALA3(SIGMA0,RALPHA);
*Compute eigenvalues of A3;
P=NROW(SIGMA0);
A2=(P/(P-1)-RALPHA)#J(P,P,1)-I(P)#P/(P-1);
FSIGMA0T=HALF(SIGMA0);
A3=FSIGMA0T*A2*FSIGMA0T`;
RETURN(EIGVAL(A3));
FINISH EVALA3;


N=10;
RALPHA=.70;
P=4;

*Constant correlation;
RHO=.50;
RHOMAT=RHOCS(P,RHO);

V_SIGMA={1 1 1 1};
D=DIAG(V_SIGMA);
SIGMA0=D*RHOMAT*D;	
CDF=CDFCRA1(SIGMA0,N,RALPHA);
PROB_F=FAPPROX(SIGMA0,N,RALPHA);
PRINT "Constant" V_SIGMA CDF[FORMAT=6.4] "  " PROB_F[FORMAT=6.4];

V_SIGMA={1 2 3 4};
D=DIAG(V_SIGMA);
SIGMA0=D*RHOMAT*D;	
CDF=CDFCRA1(SIGMA0,N,RALPHA);
PROB_F=FAPPROX(SIGMA0,N,RALPHA);
PRINT "Constant" V_SIGMA CDF[FORMAT=6.4] "  " PROB_F[FORMAT=6.4];

V_SIGMA={1 1 1 1};
D=DIAG(V_SIGMA);
  DO RHO=.20 TO .80 BY .30;
  RHOMAT=RHOAR1(P,RHO);
  SIGMA0=D*RHOMAT*D;	
  CDF=CDFCRA1(SIGMA0,N,RALPHA);
  PROB_F=FAPPROX(SIGMA0,N,RALPHA);
  PRINT "AR(1)" RHO V_SIGMA CDF[FORMAT=6.4] "  " PROB_F[FORMAT=6.4] ;
  END;

V_SIGMA={4 3 2 1};
D=DIAG(V_SIGMA);
  DO RHO=.50 TO .50 BY .30;
  RHOMAT=RHOAR1(P,RHO);
  SIGMA0=D*RHOMAT*D;	
  CDF=CDFCRA1(SIGMA0,N,RALPHA);
  PROB_F=FAPPROX(SIGMA0,N,RALPHA);
  PRINT "AR(1)" RHO V_SIGMA CDF[FORMAT=6.4] "  " PROB_F[FORMAT=6.4] ;
  END;
