TITLE1 "P0202.SAS Reproducing Numbers in Table 2 - Cronbach's alpha";
TITLE2 "Autoregressive Correlation Matrix, Variance = {3 2 1}";

proc iml;
RESET FW=6 SPACES=1;

%INCLUDE "..\IML\ARLIB1.IML"/NOSOURCE2;
%INCLUDE "..\IML\INTLIB3.IML" /  SOURCE2;
%INCLUDE "..\IML\INTLIB4.IML"/NOSOURCE2;
%INCLUDE "..\IML\AS155LB1.IML"/NOSOURCE2;

START EVALA3(SIGMA0,RALPHA);
*Compute eigenvalues of A3;
P=NROW(SIGMA0);
A2=(P/(P-1)-RALPHA)#J(P,P,1)-I(P)#P/(P-1);
FSIGMA0T=HALF(SIGMA0);
A3=FSIGMA0T*A2*FSIGMA0T`;
RETURN(EIGVAL(A3));
FINISH EVALA3;


P=3;
RHO=.5;
V_SIGMA={3 2 1};
RHOMAT=RHOAR1(P,RHO);
D=DIAG(V_SIGMA);
SIGMA0=D*RHOMAT*D;	
N=10;



  DO RALPHA=.10 to .90 BY .10;
  CDF_D=CDFCRA1(SIGMA0,N,RALPHA);

  *Compute eigenvalues of A3;
  EIGVALA3=EVALA3(SIGMA0,RALPHA);
  *PRINT RALPHA CDF_D EIGVALA3;

  PROB_F=FAPPROX(SIGMA0,N,RALPHA);
  *PRINT RALPHA PROB_F ;

  HOLD=HOLD//(RALPHA||CDF_D[1]||PROB_F[1]);

  END;

HOLD=ROUND(HOLD,.0001);
HNM={"ralpha" "CDF_D"  "PROB_F"};
PRINT HOLD[COLNAME=HNM];
